<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ParametroPosizione StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ParametroPosizione
 * @subpackage Structs
 */
class ParametroPosizione extends AbstractStructBase
{
    /**
     * The Chiave
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Chiave;
    /**
     * The Valore
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Valore;
    /**
     * Constructor method for ParametroPosizione
     * @uses ParametroPosizione::setChiave()
     * @uses ParametroPosizione::setValore()
     * @param string $chiave
     * @param string $valore
     */
    public function __construct($chiave = null, $valore = null)
    {
        $this
            ->setChiave($chiave)
            ->setValore($valore);
    }
    /**
     * Get Chiave value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getChiave()
    {
        return isset($this->Chiave) ? $this->Chiave : null;
    }
    /**
     * Set Chiave value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $chiave
     * @return \StructType\ParametroPosizione
     */
    public function setChiave($chiave = null)
    {
        // validation for constraint: string
        if (!is_null($chiave) && !is_string($chiave)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($chiave, true), gettype($chiave)), __LINE__);
        }
        if (is_null($chiave) || (is_array($chiave) && empty($chiave))) {
            unset($this->Chiave);
        } else {
            $this->Chiave = $chiave;
        }
        return $this;
    }
    /**
     * Get Valore value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getValore()
    {
        return isset($this->Valore) ? $this->Valore : null;
    }
    /**
     * Set Valore value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $valore
     * @return \StructType\ParametroPosizione
     */
    public function setValore($valore = null)
    {
        // validation for constraint: string
        if (!is_null($valore) && !is_string($valore)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($valore, true), gettype($valore)), __LINE__);
        }
        if (is_null($valore) || (is_array($valore) && empty($valore))) {
            unset($this->Valore);
        } else {
            $this->Valore = $valore;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ParametroPosizione
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
